/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 *	
 *	Copyright (C) 2012 by Embedded and Real-Time Systems Laboratory
 *				Graduate School of Information Science, Nagoya Univ., JAPAN
 *	
 *	嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *	ܥեȥѤΤޤࡥʲƱˤѡʣ
 *	ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *	(1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *		ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *		˴ޤޤƤ뤳ȡ
 *	(2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *		ѤǤǺۤˤϡۤȼɥȡ
 *		ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *		̵ݾڵǺܤ뤳ȡ
 *	(3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *		ѤǤʤǺۤˤϡΤ줫ξ
 *		ȡ
 *	  (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *		  ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *	  (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *		  𤹤뤳ȡ
 *	(4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *		⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *		ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *		ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *		դ뤳ȡ
 *	
 *	ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *	TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *	ФŬޤơʤݾڤԤʤޤܥեȥ
 *	ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *	Ǥʤ
 *	
 */

/*
 *	MPUɥ饤
 */

#ifndef TOPPERS_CORE_MPU_H
#define TOPPERS_CORE_MPU_H

/*
 *  MPUץ쥸
 *  [- 31:24] [IREGION 23:16] [DREGION 15:8] [- 7:1] SEPARATE
 */
#define MPU_TYPE    0xe000ed90
#define MPU_TYPE_IREGION    0x00ff0000
#define MPU_TYPE_DREGION    0x0000ff00
#define MPU_TYPE_SEPARATE   0x00000001

/*
 *  MPU쥸
 *  [- 31:2] PRIVDEFENA HFNMIENA ENABLE
 */
#define MPU_CR      0xe000ed94
#define MPU_CR_PRIVDEFENA   0x00000004 
#define MPU_CR_HFNMIENA     0x00000002 
#define MPU_CR_ENABLE       0x00000001

/*
 *  MPUΰֹ쥸
 *  [- 31:8] [REGION 7:0]
 */
#define MPU_REGNO   0xe000ed98
#define MPU_REGNO_REGION    0x000000ff

/*
 *  MPUΰ١ɥ쥹쥸
 *  [ADDR 31:N] [VALID 4] [REGION 3:0]
 */
#define MPU_REGBASE 0xe000ed9c
#define MPU_REGBASE_ADDR    0xffffffe0 /* ١ɥ쥹ե */
#define MPU_REGBASE_VALID   0x00000010 /* ΰֹͭӥå */
#define MPU_REGBASE_REGION  0x0000000f /* ΰֹ楪Х饤ɥե */

/*
 *  MPUΰ°ӥ쥸
 *  [- 31:29] XN - [AP 26:24] [- 23:22] [TEX 21:19] S C B [SRD 15:8] [- 7:6] [SIZE 5:1] ENABLE
 */
#define MPU_REGATR  0xe000eda0
#define MPU_REGATR_XN 0x10000000 /* ̿ᥢػߥӥå */
#define MPU_REGATR_AP 0x07000000 /* ǡĥե */
#define TO_MPU_AP(ap) (ap << 24)

/*
 *  ǡĥѥ
 */
#define MPU_AP_NOT      0x00 /* ػ */
#define MPU_AP_PRW      0x01 /* øΤߥǽ */
#define MPU_AP_PRWUR    0x02 /* 桼ɽФΤ߲ǽøϥǽ */
#define MPU_AP_PURW     0x03 /* 桼øȤ˥ǽ */
#define MPU_AP_PR       0x05 /* øΤɽФǽ */
#define MPU_AP_PUR      0x06 /* 桼øȤɽФǽ */

#define MPU_REGATR_TEX  0x00380000 /* ׳ĥե */
#define MPU_REGATR_S    0x00040000 /* ͭĥӥå */
#define MPU_REGATR_C    0x00020000 /* åĥӥå */
#define MPU_REGATR_B    0x00010000 /* Хåեĥӥå */
#define MPU_REGATR_SRD  0x0000ff00 /* ΰػߥե */
#define MPU_REGATR_SIZE 0x0000003e /* ΰ襵ե */
#define TO_MPU_SIZE(size) (size << 1)
#define MPU_REGATR_ENABLE   0x00000001 /* ΰĥӥå */

/*
 *  MPUꥢ1ΰ١ɥ쥹쥸
 */
#define MPU_AL1BASE 0xe000eda4

/*
 *  MPUꥢ1ΰ°ӥ쥸
 */
#define MPU_AL1ATR  0xe000eda8

/*
 *  MPUꥢ2ΰ١ɥ쥹쥸
 */
#define MPU_AL2BASE 0xe000edac

/*
 *  MPUꥢ2ΰ°ӥ쥸
 */
#define MPU_AL2ATR  0xe000edb0

/*
 *  MPUꥢ3ΰ١ɥ쥹쥸
 */
#define MPU_AL3BASE 0xe000edb4

/*
 *  MPUꥢ3ΰ°ӥ쥸
 */
#define MPU_AL3ATR  0xe000edb8

/*
 *  㳰ֹ
 */
// ݸȿ
#define EXCNO_MEM_MNG       0x04

#ifndef TOPPERS_MACRO_ONLY
// 롼 
extern void target_mpu_initialize(void);
// ݸȿ㳰ϥɥ
extern void target_mpu_exc_handler(void *p_excinf);
// 㳰¹Գϻåϥɥ
extern void target_emulate_texrtn_handler(void *p_excinf);
// 㳰꥿åϥɥ
extern void target_emulate_ret_tex_handler(void *p_excinf);

#endif /* TOPPERS_MACRO_ONLY */
#endif /* TOPPERS_CORE_MPU_H */
