/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2011-2012 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: prc_timer.c 2106 2011-06-21 13:46:09Z ertl-honda $
 */

/*
 *  ޥɥ饤СLM3SXXXXѡ
 */

#include "kernel_impl.h"
#include "time_event.h"
#include <sil.h>
#include "target_timer.h"
#include "inc/hw_memmap.h"
#include "inc/hw_types.h"
#include "inc/hw_sysctl.h"
#include "driverlib/sysctl.h"
#include "driverlib/gpio.h"
#include "driverlib/timer.h"

#ifdef TOPPERS_TARGET_SUPPORT_OVRHDR

/*
 *	Х󥿥ޤν
 *
 *	ޤ롥
 */
void
target_ovrtimer_initialize(intptr_t exinf)
{
    /*  */
	SysCtlPeripheralEnable(SYSCTL_PERIPH_TIMER0);
	SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOD);
	GPIOPinTypeTimer(GPIO_PORTD_BASE, GPIO_PIN_4);
    TimerConfigure(TIMER0_BASE, TIMER_CFG_ONE_SHOT);
    /* ߵ */
    TimerIntEnable(TIMER0_BASE, TIMER_TIMA_TIMEOUT);
}

/*
 *	Х󥿥ޤνλ
 *
 *	ޤưλ롥
 */
void
target_ovrtimer_terminate(intptr_t exinf)
{
    /* ޤ */
    TimerDisable(TIMER0_BASE, TIMER_A);
    /* ׵򥯥ꥢ */
    TimerIntClear(TIMER0_BASE, TIMER_TIMA_TIMEOUT);
}

/*
 *	Х󥿥ޤεư
 *
 *	ޤư롥
 */
void
target_ovrtimer_start(OVRTIM ovrtim)
{
	CLOCK	 cyc = OVRTIMER_CLOCK(ovrtim) - 1;

    /*
     *  ޼ꤷޤư򳫻Ϥ롥
     */
    assert(cyc <= MAX_OVRTIMER_CLOCK);          /* ޾ͤΥå */

    TimerLoadSet(TIMER0_BASE, TIMER_A, cyc);    /* 󥿡򥻥å */

    /* ׵򥯥ꥢ */
    TimerIntClear(TIMER0_BASE, TIMER_TIMA_TIMEOUT);

    /* 0_A */
    TimerEnable(TIMER0_BASE, TIMER_A);
}

/*
 *	Х󥿥ޤ߽
 *
 *	ޤưߤ롥
 */
OVRTIM
target_ovrtimer_stop(void)
{
    OVRTIM rest;

    /* ޤ */
    TimerDisable(TIMER0_BASE, TIMER_A);
    /* ׵򥯥ꥢ */
    TimerIntClear(TIMER0_BASE, TIMER_TIMA_TIMEOUT);

	rest = (OVRTIM)TimerValueGet(TIMER0_BASE, TIMER_A);

    if(rest < 0){
        return 1;
    } else {
        return (OVRTIMER_USEC(rest + 1));
    }
}

/*
 *	Х󥿥ޤλĤ֤ɽФ
 */
OVRTIM
target_ovrtimer_get_current(void)
{
    OVRTIM rest;

	rest = (OVRTIM)TimerValueGet(TIMER0_BASE, TIMER_A);

    if(rest < 0){
        return 0;
    } else {
        return (OVRTIMER_USEC(rest + 1));
    }
}

/*
 *	Х󥿥޳ߥϥɥ
 */
void
target_ovrtimer_handler(void)
{
	i_begin_int(INTNO_OVRTIMER);
	call_ovrhdr();
	i_end_int(INTNO_OVRTIMER);
}

#endif /* TOPPERS_TARGET_SUPPORT_OVRHDR */

